// MirrorItView.h : interface of the CMirrorItView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MIRRORITVIEW_H__C2396A6F_40C6_11D1_83C6_0000C0003048__INCLUDED_)
#define AFX_MIRRORITVIEW_H__C2396A6F_40C6_11D1_83C6_0000C0003048__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define C_COLUMNS           3
#define COLUMN_SESSION      0
#define COLUMN_URL          1
#define COLUMN_COMMENT      2

#define UPDATE_ADD			1000
#define UPDATE_MODIFY		1001
#define UPDATE_REMOVE		1002
#define UPDATE_MOVE			1003

class CSession;

class CMirrorItView : public CListView
{
protected: // create from serialization only
	CMirrorItView();
	DECLARE_DYNCREATE(CMirrorItView)

// Attributes
public:
	CMirrorItDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMirrorItView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	CImageList m_ilSmall;
	CImageList m_ilLarge;
	afx_msg void OnUpdateEditCopyCut(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnEditPaste();
	BOOL IsSelected();
	void DoCutCopyPaste(CArchive &ar, BOOL bCut);
	UINT m_nClipboardFormat;
	void UpdateSession(int n, CSession * session);
	void AddSession(CSession * session);
	virtual ~CMirrorItView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	void UpdateListView(CCmdUI * pCmdUI, DWORD dwView);
	void SetListView(DWORD dwView);
	//{{AFX_MSG(CMirrorItView)
	afx_msg void OnViewDetails();
	afx_msg void OnViewLargeicons();
	afx_msg void OnViewList();
	afx_msg void OnViewSmallicons();
	afx_msg void OnUpdateViewSmallicons(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewList(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewLargeicons(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewDetails(CCmdUI* pCmdUI);
	afx_msg void OnSessionProperties();
	afx_msg void OnUpdateSessionProperties(CCmdUI* pCmdUI);
	afx_msg void OnSessionRemove();
	afx_msg void OnUpdateSessionRemove(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditClear(CCmdUI* pCmdUI);
	afx_msg void OnEditClear();
	afx_msg void OnSessionAdd();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnUpdateSessionMovedown(CCmdUI* pCmdUI);
	afx_msg void OnSessionMovedown();
	afx_msg void OnSessionMoveup();
	afx_msg void OnUpdateSessionMoveup(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSessionStart(CCmdUI* pCmdUI);
	afx_msg void OnSessionStart();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MirrorItView.cpp
inline CMirrorItDoc* CMirrorItView::GetDocument()
   { return (CMirrorItDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MIRRORITVIEW_H__C2396A6F_40C6_11D1_83C6_0000C0003048__INCLUDED_)
